# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to tweak Makefile.PL if we don't have ExtUtils::MakeMaker ≥ 6.58
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.58) ? 1 : 0);' 2>/dev/null || echo 0)

# Have to use List::MoreUtils rather than List::Util on old perls with List::Util < 1.33
%global old_list_util 0%{?fedora} < 21 && 0%{?rhel} < 8

Name:		perl-Module-CPANTS-Analyse
Version:	1.01
Release:	1.%{__distinit}%{__distvers}
Summary:	Generate Kwalitee ratings for a distribution
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/Module-CPANTS-Analyse
Source0:	https://cpan.metacpan.org/modules/by-module/Module/Module-CPANTS-Analyse-%{version}.tar.gz
Patch0:		Module-CPANTS-Analyse-0.95-old-EU:MM.patch
Patch1:		Module-CPANTS-Analyse-1.01-old-List::Util.patch
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(ExtUtils::MakeMaker::CPANfile) >= 0.08
# Module Runtime
BuildRequires:	perl(Archive::Any::Lite) >= 0.06
BuildRequires:	perl(Archive::Tar) >= 1.76
BuildRequires:	perl(Array::Diff) >= 0.04
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Class::Accessor) >= 0.19
BuildRequires:	perl(Class::Accessor::Fast)
BuildRequires:	perl(CPAN::DistnameInfo) >= 0.06
BuildRequires:	perl(CPAN::Meta::Converter)
BuildRequires:	perl(CPAN::Meta::Validator) >= 2.133380
BuildRequires:	perl(CPAN::Meta::YAML) >= 0.008
BuildRequires:	perl(Data::Binary)
BuildRequires:	perl(Encode)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::Manifest)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Copy)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Find::Object) >= 0.2.1
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(File::stat)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(JSON::PP)
BuildRequires:	perl(List::Util)
%if %{old_list_util}
BuildRequires:	perl(List::MoreUtils)
%endif
BuildRequires:	perl(Module::CPANfile)
BuildRequires:	perl(Perl::PrereqScanner::NotQuiteLite) >= 0.9901
BuildRequires:	perl(Module::Find)
BuildRequires:	perl(Software::License) >= 0.103012
BuildRequires:	perl(Software::LicenseUtils)
BuildRequires:	perl(strict)
BuildRequires:	perl(Text::Balanced)
BuildRequires:	perl(version) >= 0.73
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Cwd)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::FailWarnings)
BuildRequires:	perl(Test::More) >= 0.88
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Archive::Any::Lite) >= 0.06
Requires:	perl(Archive::Tar) >= 1.76
Requires:	perl(Array::Diff) >= 0.04
Requires:	perl(Class::Accessor) >= 0.19
Requires:	perl(Class::Accessor::Fast)
Requires:	perl(CPAN::DistnameInfo) >= 0.06
Requires:	perl(CPAN::Meta::Validator) >= 2.133380
Requires:	perl(CPAN::Meta::YAML) >= 0.008
Requires:	perl(Exporter)
Requires:	perl(File::Find::Object) >= 0.2.1
Requires:	perl(JSON::PP)
Requires:	perl(Module::CPANfile)
Requires:	perl(Software::License) >= 0.103012
Requires:	perl(version) >= 0.73

%description
CPANTS is an acronym for CPAN Testing Service. The goals of the CPANTS project
are to provide some sort of quality measure (called "Kwalitee") and lots of
metadata for all distributions on CPAN.

%prep
%setup -q -n Module-CPANTS-Analyse-%{version}

# We need to tweak Makefile.PL if we don't have ExtUtils::MakeMaker ≥ 6.58
%if %{old_eumm}
%patch0
%endif

# Have to use List::MoreUtils rather than List::Util on old perls
%if %{old_list_util}
%patch1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc AUTHORS Changes README.md TODO
%{perl_vendorlib}/Module/
%{_mandir}/man3/Module::CPANTS::Analyse.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::BrokenInstaller.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::CpantsErrors.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Distname.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Distros.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Files.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::FindModules.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::License.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Manifest.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::MetaYML.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::NeedsCompiler.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Pod.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Prereq.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Repackageable.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Signature.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Uses.3*
%{_mandir}/man3/Module::CPANTS::Kwalitee::Version.3*

%changelog
* Mon Aug 12 2019 Paul Howarth <paul@city-fan.org> - 1.01-1
- Update to 1.01
  - Fixed not to set an error message when extracted nicely
  - Fixed to restore mtime of MANIFEST.SKIP if it is modified by
    #include_default
  - Improved primary module detection
  - Fixed to catch CPAN::Meta::YAML's warnings (of duplicate keys)
  - Improved test_prereqs_match to handle t::lib::Util, and ignore files that
    contain but don't end with .t
  - Fixed to store multiple licenses in META files

* Fri Jun  7 2019 Paul Howarth <paul@city-fan.org> - 1.00-2
- Perl 5.30 rebuild

* Sun Feb  3 2019 Paul Howarth <paul@city-fan.org> - 1.00-1
- Update to 1.00
  - Module::CPANTS::Kwalitee::Uses now uses a different prereq scanner
    (Perl::PrereqScanner::NotQuiteLite)
  - Added new kwalitee metrics:
    no_maniskip_error, no_missing_files_in_provides, no_files_to_be_skipped
  - Delayed plugin loading
- Upstream no longer ships the extra tests, so don't try to run them

* Tue Jan 15 2019 Paul Howarth <paul@city-fan.org> - 0.99-1
- Update to 0.99
  - Module::CPANTS::Kwalitee now uses Module::Find to find Kwalitee modules
    (instead of Module::Pluggable, which unconditionally spits a deprecation
    warning); you usually don't need to care but if you have your custom
    Kwalitee plugin loader (such as Module::CPANTS::SiteKwalitee), you need to
    change it - sorry for the inconvenience
  - Allow dash and dot in script name in the NAME section for
    non-pm, non-pod files
  - Added has_meta_json metric (CPAN RT#107885)
  - Accept a few more README extensions
  - Accept two more Moose modules as strict equivalents
  - Various micro optimization for performance
  - Dropped a few dependencies
  - Various documentation updates
  - Not to check use_strict/use_warnings for Perl 6 modules in a Perl 5
    distribution
  - Worked around a File::Find::Object issue
  - Fixed dynamic_config handling
  - Improved LICENSE file detection (CPAN RT#114247)
  - Skip everything in MANIFEST.SKIP while testing symlinks (GH#33)
- Switch upstream from search.cpan.org to metacpan.org

* Thu Apr 26 2018 Paul Howarth <paul@city-fan.org> - 0.96-9
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.88

* Tue Sep  6 2016 Paul Howarth <paul@city-fan.org> - 0.96-5
- BR: perl-generators where available
- Simplify find command using -delete

* Mon Nov 24 2014 Paul Howarth <paul@city-fan.org> - 0.96-1
- Update to 0.96
  - Added an import option to load extra Kwalitee plugins
  - has_readme now accepts README.pod as well (CPAN RT#100512)
  - Improved no_abstract_stub_in_pod to detect "The great new" as a boilerplate
  - Switched to File::Find::Object

* Mon Sep 29 2014 Paul Howarth <paul@city-fan.org> - 0.95-1
- Update to 0.95
  - Added the following metrics:
    - has_abstract_in_pod
    - has_known_license_in_source_file
    - meta_json_conforms_to_known_spec
    - meta_json_is_parsable
    - meta_yml_has_repository_resource
    - no_abstract_stub_in_pod
  - Removed metayml_conforms_spec_current metric
  - Renamed metayml_ metrics to meta_yml_
  - Removed cpants_lint.pl in favor of App::CPANTS::Lint
  - Supported x_cpants custom META field to tell analyzer to ignore some of
    the metrics (only) when calculating a kwalitee score
  - Refactored several Kwalitee files, and internal stash layout has changed
    rather significantly; you might need to modify your tools if they happen
    to depend on the stash directly
  - Refactored tests
  - Fixed CPAN RT#94468 - use_strict metric doesn't like .pod files that
    contain no perl
  - Fixed CPAN RT#99141 - use_strict metric does not recognize "use v5.14"
    syntax
  - Fixed abstract encoding issues
  - Fixed not to ignore directory symlinks
  - Fixed CPAN RT#97858 - wrong no_symlinks test in files not in MANIFEST (for
    a local distribution; CPANTS site doesn't ignore symlinks not listed in
    MANIFEST)
  - Fixed CPAN RT#97601 - Test::Kwalitee incorrectly reports non-use of strict
    in Inline::CPP
  - Accept COPYING as a license file
  - Take included module (under inc/) into consideration while analyzing
    prereq_matches_use
  - Changed most of the META.yml metrics to pass if META.yml doesn't exist
  - Switched to Test::FailWarnings to make CPAN testers happier
- Switch to ExtUtils::MakeMaker flow
- Classify buildreqs by usage
- Bundle a more recent Test::More for when the system version is too old
- Patch Makefile.PL to specify multiple authors differently with
  ExtUtils::MakeMaker < 6.58

* Thu Sep 11 2014 Paul Howarth <paul@city-fan.org> - 0.92-3
- Drop %%defattr, redundant since rpm 4.4

* Sun Sep 22 2013 Paul Howarth <paul@city-fan.org> - 0.92-1
- Update to 0.92 release
  - Fixed a case when more than one license section came in a row
  - Stopped checking auto_features

* Thu Sep  5 2013 Paul Howarth <paul@city-fan.org> - 0.91-1
- Update to 0.91 release
  - Add metrics no_dot_underscore_files, portable_filenames
  - Remove metrics distributed_by_debian, latest_version_distributed_by_debian,
    has_no_bugs_reported_in_debian, has_no_patches_in_debian, no_cpants_errors,
    uses_test_nowarnings, has_test_pod, has_test_pod_coverage, has_examples
  - Removed a few non-portable metrics for Test::Kwalitee
  - Numerous fixes for a smoother operation of www-cpants
  - Fixed CPAN RT#87535: incorrect version specification in 0.90_01
  - Fixed CPAN RT#87534: test failure in 0.90_01
  - Fixed CPAN RT#87561: t/11_hash_random.t fails due to undeclared test
    dependency
  - Fixed CPAN RT#69233: doesn't detect 'use' ≥ 5.012 as 'use strict'
  - Fixed CPAN RT#83336: fails to detect strict via 'use MooseX::Types'
  - Fixed CPAN RT#83851: 'use v5.16' and greater not deemed "strict"
  - Fixed CPAN RT#86504: fix sort order of Kwalitee generators
  - Fixed CPAN RT#87155: more Module::Install tests needed (1.04 is broken)
  - Fixed CPAN RT#87597: proper_libs is a dubious test
  - Fixed CPAN RT#87598: can't use an undefined value as an ARRAY reference at
    .../FindModules.pm line 115
  - Fixed CPAN RT#87988: fix use of $Test::Kwalitee::VERSION
  - Fixed CPAN RT#88216: extracts_nicely metric fails for -TRIAL releases
  - Fixed CPAN RT#88365: YAML/JSON tests are not failing when improperly
    encoded characters are seen
  - Moose::Exporter also provides strict and warnings
- Drop no-net patch, no longer needed
- Drop upstreamed POD coverage and Test::More test patches
- Don't run the author test (Perl::Critic) as it would fail anyway
- Module no longer checks signatures, so drop all related hacks
- No longer need to fix line endings

* Thu Aug  1 2013 Paul Howarth <paul@city-fan.org> - 0.89-1
- Update to 0.89 release
  - Additional tests
- This release by ISHIGAKI -> update source URL
- BR: various missed dependency modules
- Add patch to support building with Test::More < 0.88
- Avoid calling debian when building (debian #542401)
- Add patch to work around failing POD coverage test on some perls

* Mon Feb 25 2013 Paul Howarth <paul@city-fan.org> - 0.87-1
- Update to 0.87 release
  - Fix test failures due to Test::CPAN::Meta::YAML::Version interface change
    (CPAN RT#80225)
  - Fix failure in 10_analyse.t due to hash randomization (CPAN RT#82939)
  - Module::CPANTS::Kwalitee::Manifest was broken for MANIFESTs containing
    files with spaces (CPAN RT#44796)
- Bump version requirements for Module::ExtractUse and
  Test::CPAN::Meta::YAML::Version as per upstream

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 0.86-3
- Perl 5.16 post-bootstrap rebuild

* Tue Jul 10 2012 Paul Howarth <paul@city-fan.org> - 0.86-2
- Perl 5.16 rebuild

* Sun May 27 2012 Paul Howarth <paul@city-fan.org> - 0.86-1
- Update to 0.86 release
  - Add several strict and warnings equivalents and make it easy to add more
  - Fix when Moose is used and strict is not used
  - Add info about MIN_PERL_VERSION
  - Better remedy for metayml_declares_perl_version
  - metayml_declares_perl_version moved from experimental to extra
  - Some pod improvements
  - Fix CPAN RT#65903 - no more Test::YAML::Meta::Version on CPAN
  - Replace YAML::Syck with YAML::Any
  - no_symlinks checks only files in MANIFEST, use "maniread" in
    ExtUtils::Manifest
  - Add more equivalents for use_strict and use_warnings tests
  - Implement valid_signature metric
- This release by DAXIM -> update source URL
- Drop patch for Test::CPAN::Meta::YAML::Version, no longer needed
- Bump module version requirements:
  - perl(Archive::Tar) => 1.48
  - perl(Module::Build) => 0.40
  - perl(Software::License) => 0.003
  - perl(Test::Warn) => 0.11
  - perl(Text::CSV_XS) => 0.45
- BR: perl(Cwd), perl(ExtUtils::Manifest), perl(File::chdir),
  perl(Module::Signature), perl(Set::Scalar) and perl(Test::Pod::Coverage)
- BR: perl(YAML::Any) rather than perl(YAML::Syck)
- Drop perl(Test::CPAN::Meta::YAML::Version) version requirement
- Work around signature compatibility issues with GnuPG < 1.3

* Wed Mar  7 2012 Paul Howarth <paul@city-fan.org> - 0.85-11
- Don't need to remove empty directories from buildroot
- Drop support for distributions prior to FC-3:
  - Don't need use %%attr for cpants_lint.pl
  - Don't need to define %%{perl_vendorlib}
  - Don't need to run tests with LC_ALL=C
  - Perl::Critic always available

* Wed Feb  8 2012 Paul Howarth <paul@city-fan.org> - 0.85-10
- Don't BR: perl(Test::Perl::Critic) when bootstrapping

* Wed Jun 29 2011 Paul Howarth <paul@city-fan.org> - 0.85-9
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Mar 17 2011 Paul Howarth <paul@city-fan.org> - 0.85-8
- Import from Fedora

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.85-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Dec 20 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.85-6
- Rebuild to fix problems with vendorarch/lib (#661697)

* Mon May 03 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.85-5
- Mass rebuild with perl-5.12.0

* Tue Jan 12 2010 Daniel P. Berrange <berrange@redhat.com> - 0.85-4
- Fix source URL

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.85-3
- Rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.85-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 22 2009 Daniel P. Berrange <berrange@redhat.com> - 0.85-1
- Update to 0.85 release

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.82-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Oct  3 2008 Daniel P. Berrange <berrange@redhat.com> - 0.82-2
- Added more new & missing BRs

* Fri Sep  5 2008 Daniel P. Berrange <berrange@redhat.com> - 0.82-1
- Update to 0.82 release

* Fri Feb  8 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.75-3
- Rebuild for new perl

* Wed Dec 26 2007 Daniel P. Berrange <berrange@redhat.com> - 0.75-2
- Added Test::Deep, Test::Pod, Test::Pod::Coverage build requires

* Fri Dec 21 2007 Daniel P. Berrange <berrange@redhat.com> - 0.75-1
- Specfile autogenerated by cpanspec 1.73
